# File generated from our OpenAPI spec by Stainless. See CONTRIBUTING.md for details.

from __future__ import annotations

import os
from typing import Any, cast

import pytest

from tests.utils import assert_matches_type
from sink.api.sdk import Sink, AsyncSink
from sink.api.sdk.types.model_referenced_in_parent_and_child import ModelReferencedInParentAndChild

base_url = os.environ.get("TEST_API_BASE_URL", "http://127.0.0.1:4010")


class TestModelReferencedInParentAndChild:
    parametrize = pytest.mark.parametrize("client", [False, True], indirect=True, ids=["loose", "strict"])

    @parametrize
    def test_method_retrieve(self, client: Sink) -> None:
        model_referenced_in_parent_and_child = client.model_referenced_in_parent_and_child.retrieve()
        assert_matches_type(ModelReferencedInParentAndChild, model_referenced_in_parent_and_child, path=["response"])

    @parametrize
    def test_raw_response_retrieve(self, client: Sink) -> None:
        response = client.model_referenced_in_parent_and_child.with_raw_response.retrieve()

        assert response.is_closed is True
        model_referenced_in_parent_and_child = response.parse()
        assert_matches_type(ModelReferencedInParentAndChild, model_referenced_in_parent_and_child, path=["response"])

    @parametrize
    def test_streaming_response_retrieve(self, client: Sink) -> None:
        with client.model_referenced_in_parent_and_child.with_streaming_response.retrieve() as response:
            assert not response.is_closed

            model_referenced_in_parent_and_child = response.parse()
            assert_matches_type(
                ModelReferencedInParentAndChild, model_referenced_in_parent_and_child, path=["response"]
            )

        assert cast(Any, response.is_closed) is True


class TestAsyncModelReferencedInParentAndChild:
    parametrize = pytest.mark.parametrize("async_client", [False, True], indirect=True, ids=["loose", "strict"])

    @parametrize
    async def test_method_retrieve(self, async_client: AsyncSink) -> None:
        model_referenced_in_parent_and_child = await async_client.model_referenced_in_parent_and_child.retrieve()
        assert_matches_type(ModelReferencedInParentAndChild, model_referenced_in_parent_and_child, path=["response"])

    @parametrize
    async def test_raw_response_retrieve(self, async_client: AsyncSink) -> None:
        response = await async_client.model_referenced_in_parent_and_child.with_raw_response.retrieve()

        assert response.is_closed is True
        model_referenced_in_parent_and_child = await response.parse()
        assert_matches_type(ModelReferencedInParentAndChild, model_referenced_in_parent_and_child, path=["response"])

    @parametrize
    async def test_streaming_response_retrieve(self, async_client: AsyncSink) -> None:
        async with async_client.model_referenced_in_parent_and_child.with_streaming_response.retrieve() as response:
            assert not response.is_closed

            model_referenced_in_parent_and_child = await response.parse()
            assert_matches_type(
                ModelReferencedInParentAndChild, model_referenced_in_parent_and_child, path=["response"]
            )

        assert cast(Any, response.is_closed) is True
